﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
#Event: StateChanged(StateValue as String)
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFF808080, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonWidth, DisplayName: Button Width, FieldType: int, DefaultValue: 35, Description: Value between 1 to 100% of object width
#DesignerProperty: Key: ButtonLeftColor, DisplayName: Button Left Color, FieldType: Color, DefaultValue: 0x4BFF0000, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonRightColor, DisplayName: Button Right Color, FieldType: Color, DefaultValue: 0x4B00FF00, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonBorderColor, DisplayName: Button Border Color, FieldType: Color, DefaultValue: 0xFFD3D3D3, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonTextColor, DisplayName: Button Text Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonRadius, DisplayName: Button Radius, FieldType: Int, DefaultValue: 60, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonLeftText, DisplayName: Button Left Text, FieldType: String, DefaultValue: , Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: ButtonRightText, DisplayName: Button Right Text, FieldType: String, DefaultValue: , Description: Setting the default value to Null means that a nullable field will be displayed.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore

	Private p1, p2, p3 As Panel
	Private color1, color2 As GradientDrawable
	Private color3 As ColorDrawable
	Private col1(2), col2(2), col3(2) As Int
	Private posLeft = True As Boolean
	Private border As Int
	Private label As B4XView
	
	Private mBgColor, mLeftColor, mRightColor, mBorderColor, mRadius, mButtonWidth As Int
	Private mLeftText, mRightText, mStateValue As String
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mBgColor = Props.Get("BackgroundColor")
	mButtonWidth = Props.Get("ButtonWidth")
	mLeftColor = Props.Get("ButtonLeftColor")
	mRightColor = Props.Get("ButtonRightColor")
	mBorderColor = Props.Get("ButtonBorderColor")
	mRadius = Props.Get("ButtonRadius")
	mLeftText = Props.Get("ButtonLeftText")
	mRightText = Props.Get("ButtonRightText")
	
	
	mBase.Color = xui.Color_Transparent
	col1(0) = mBgColor
	col1(1) = 0xFFE6E6E6 'xui.Color_White
	color1.Initialize("TOP_BOTTOM",col1)
	color1.CornerRadius = mRadius
		
	col2(0) = mBgColor
	col2(1) = 0xFFE6E6E6 'xui.Color_white
	color2.Initialize("BOTTOM_TOP",col2)
	color2.CornerRadius = mRadius
	
	border = 0.07 * mBase.Height

	col3(0) = mLeftColor
	col3(1) = mRightColor
	color3.Initialize2(col3(0),mRadius,border,mBorderColor)

	p1.Initialize("")
	p1.Background = color2
	mBase.AddView(p1,0,0,mBase.Width,mBase.Height)
	
	p2.Initialize("pnl2")
	p2.Background = color1
	mBase.AddView(p2,border,border,mBase.Width-border*2,mBase.Height-border*2)

	p3.Initialize("")
	p3.Background = color3
	mBase.AddView(p3,p2.Left,p2.Top,p2.Width * (mButtonWidth/100),p2.Height)

	Dim font As B4XFont = xui.CreateFont(Typeface.DEFAULT_BOLD,14)
	label = Lbl
	label.Font = font
	label.Text = mLeftText
	label.TextColor = Props.Get("ButtonTextColor")
	label.SetTextAlignment("CENTER","CENTER")
	p3.AddView(label,0,0,p3.Width, p3.Height)
	mStateValue = mLeftText
End Sub

private Sub pnl2_Click
	If posLeft  Then
		p3.SetColorAnimated(400,col3(0), col3(1))
		p3.SetLayoutAnimated(400,p2.Width - p3.Width+border,p3.Top,p3.Width,p3.Height)
		Sleep(200)
		label.Text = mRightText
	Else
		p3.SetColorAnimated(400,col3(1), col3(0))
		p3.SetLayoutAnimated(400,p2.Left,p3.Top,p3.Width,p3.Height)
		Sleep(200)
		label.Text = mLeftText
	End If
	mStateValue = label.Text
	posLeft = Not(posLeft)
	If xui.SubExists(mCallBack, mEventName & "_StateChanged",0) Then CallSubDelayed2(mCallBack,mEventName & "_StateChanged",mStateValue)
End Sub

Public Sub SetStateValue(isLeft As Boolean)
	posLeft = Not(isLeft)
	pnl2_Click
End Sub

Public Sub GetStateText As String
	If posLeft Then 
		Return mRightText
	Else
		Return mLeftText
	End If
End Sub

Public Sub LeftState As Boolean
	Return posLeft
End Sub

Public Sub ToggleState
	pnl2_Click
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub